// PCI_DIO_IODlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCI_DIO_IO.h"
#include "PCI_DIO_IODlg.h"
#include <MATH.H>

/* Include files */
#include "PCI_DIO.h"
#include "PCI_DIO_Error.h"
#include "TYPE_DEF.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/*PCI_DIO*/
const unsigned short PCI_DIO_MaxAxesNum = 12;
U8 ExistIOCards = 0;
U8 PCI_DIO_CardNo = 0;
U16 DIO_CardNo;
CString XX;		
bool gbIsTimer = false;		
U16 PCI_DIO_CardNoList[PCI_DIO_MaxAxesNum] = {0};					
/////////////////////////////////////////////////////////////////////////////
// CPCI_DIO_IODlg dialog

CPCI_DIO_IODlg::CPCI_DIO_IODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCI_DIO_IODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCI_DIO_IODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCI_DIO_IODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCI_DIO_IODlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCI_DIO_IODlg, CDialog)
	//{{AFX_MSG_MAP(CPCI_DIO_IODlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN_CARD, OnBtnOpenCard)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHK_TIMER, OnChkTimer)
	ON_CBN_SELCHANGE(IDC_CmbCardNo, OnEditchangeCmbCardNo)			
	//}}AFX_MSG_MAP
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCI_DIO_IODlg message handlers

BOOL CPCI_DIO_IODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CComboBox *CComboBox;							

	// TODO: Add extra initialization here

	SetDlgItemText(IDC_EDT_EXIST_CARD, "0");

	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCI_DIO_IODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCI_DIO_IODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPCI_DIO_IODlg::OnBtnOpenCard() 
{
	I16 rt;
	U16 i, j,CardNo, fpga_version,DeviceID, SlotID = 0,CardNum;
	U32 DeviceType, IdentityObject;
	U32 lMask = 0x1;

	KillTimer(0);//
	CButton* lpBtnPtr;

	((CButton*)GetDlgItem(IDC_CHK_TIMER))->SetCheck(0);

	((CComboBox*)GetDlgItem(IDC_CmbCardNo))->ResetContent();	
		
	lpBtnPtr = (CButton *)GetDlgItem(IDC_CHK_TIMER);			
	lpBtnPtr->SetCheck(0);										
	lpBtnPtr = (CButton *)GetDlgItem(IDC_CHK_TIMER);			
	lpBtnPtr->EnableWindow(false);			
	
	rt = _PCI_DIO_open_card(&ExistIOCards);//Open IO Card
    if(ExistIOCards == 0)
        AfxMessageBox("PCI-DIO card cant be found!");
    else 
	{
		SetDlgItemInt(IDC_EDT_EXIST_CARD, ExistIOCards, true);
		
		for(i=0; i<ExistIOCards; i++) 
		{

			rt = _PCI_DIO_get_card_no(i, &CardNo);//Get IO_CardNo
			PCI_DIO_CardNoList[i] = CardNo;
			
			if(rt != 0) AfxMessageBox("Can't boot PCI_DIO Master Card!");
			else
			{
				XX.Format("%d",PCI_DIO_CardNoList[i]);
				((CComboBox*)GetDlgItem(IDC_CmbCardNo))->AddString(XX);
				CardNum++;
			}
		}
		if(CardNum!=0)
		{
			((CComboBox*)GetDlgItem(IDC_CmbCardNo))->SetCurSel(0);					
			((CComboBox*)GetDlgItem(IDC_CmbCardNo))->GetWindowText(XX);				
			DIO_CardNo=atoi(XX);
			PCI_DIO_CardNo = atoi(XX);
			((CButton*)GetDlgItem(IDC_CmbCardNo))->EnableWindow(TRUE);													
		}
	}

	((CButton*)GetDlgItem(IDC_CHK_TIMER))->EnableWindow(TRUE);
	SetTimer(0, 20, NULL);
}

void CPCI_DIO_IODlg::OnOK() 
{
	KillTimer(0);//close Timer 0

	_PCI_DIO_close();//close IO card

	CDialog::OnOK();

}

void CPCI_DIO_IODlg::OnTimer(UINT nIDEvent) 
{
	CString xx;
	I16 rt;
	unsigned short fpga_version, DeviceID;

	if(gbIsTimer) 
	{

			rt = _PCI_DIO_get_fpga_version(PCI_DIO_CardNo, &fpga_version);//Get FPGA_version
			XX.Format("0x%x",fpga_version);
			SetDlgItemText(IDC_EDT_VERSION, XX);
			rt = _PCI_DIO_get_hardware_id(PCI_DIO_CardNo, &DeviceID);//Get HardwareID
			XX.Format("0x%x",DeviceID);
			SetDlgItemText(IDC_EDT_Hardware_ID, XX);

	}
	
	CDialog::OnTimer(nIDEvent);
}

void CPCI_DIO_IODlg::OnChkTimer() 
{	
	int chk;
	CButton *lpBtnPtr;
	chk=((CButton*)GetDlgItem(IDC_CHK_TIMER))->GetCheck();
	
	if(chk==1)
	{
		gbIsTimer=true;
	}
	else
	{
		gbIsTimer=false;
	}
}


void CPCI_DIO_IODlg::OnEditchangeCmbCardNo() 
{
	CButton* lpBtnPtr;
	
	//lpBtnPtr = (CButton *)GetDlgItem(IDC_CHK_TIMER);				
	//lpBtnPtr->SetCheck(0);											
	//lpBtnPtr = (CButton *)GetDlgItem(IDC_CHK_TIMER);				
	//lpBtnPtr->EnableWindow(false);									
	((CComboBox*)GetDlgItem(IDC_CmbCardNo))->GetCurSel();			
	((CComboBox*)GetDlgItem(IDC_CmbCardNo))->GetWindowText(XX);		
	PCI_DIO_CardNo=atoi(XX);//Update combobox change CardNo	
	OnChkTimer();
	
}



